#include <includes.h>

OS_EVENT *RecPackedFlag;
OS_EVENT *RecBufOverFlowFlag;
OS_EVENT *RecTcpPackedFlag;
OS_EVENT *RecPingPackedFlag;

/*********************************************************************************************************
    TASK STACK
*********************************************************************************************************/
OS_STK TASK_UDP_Process_stack[TASK_UDP_Process];
OS_STK TASK_TCP_Process_stack[TASK_TCP_Process];
OS_STK TASK_ARP_Process_stack[TASK_ARP_Process];

/*********************************************************************************************************
    uC/OS-IĨVXe^C}̏
*********************************************************************************************************/
static void tickInit(void)
{
    SysTickPeriodSet((INT32U)(SysCtlClockGet() / OS_TICKS_PER_SEC) -1 );
    SysTickEnable();
    SysTickIntEnable();
}

/*********************************************************************************************************
    VXe^C}̃^CAEg荞݃nh
*********************************************************************************************************/
void tickISRHandler(void)
{
    #if OS_CRITICAL_METHOD == 3
        OS_CPU_SR cpu_sr;
    #endif

    OS_ENTER_CRITICAL();
    OSIntNesting++;
    OS_EXIT_CRITICAL();

    OSTimeTick();

    OSIntExit();
}

/*********************************************************************************************************
    ^[Qbg{[h̏
*********************************************************************************************************/
void targetInit(void)
{
    #if PLL_EN == 0
        SysCtlClockSet(CCLK_DIV | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN | EXT_CLK);
    #else
        SysCtlClockSet(CCLK_DIV | SYSCTL_USE_PLL | SYSCTL_OSC_MAIN | EXT_CLK);
    #endif

    tickInit();
    
    SetNetPort();
    InitNic(0);
    Tcp_Initial();
    Udp_Initial();
    
    // TCP,UDP^XN쐬
    OSTaskCreate(UDP_Process, (void *)0, &TASK_UDP_Process_stack[TASK_UDP_Process - 1], TASK_UDP_Process_PRIO);
    OSTaskCreate(TCP_Process, (void *)0, &TASK_TCP_Process_stack[TASK_TCP_Process - 1], TASK_TCP_Process_PRIO);
    OSTaskCreate(ARP_Process, (void *)0, &TASK_ARP_Process_stack[TASK_ARP_Process - 1], TASK_ARP_Process_PRIO);
    
    // etO
    RecPackedFlag      = OSSemCreate(0);
    RecBufOverFlowFlag = OSSemCreate(0);
    RecTcpPackedFlag   = OSSemCreate(0);
    RecPingPackedFlag  = OSSemCreate(0);
    SendFlag           = OSSemCreate(1);
    RecIcmpQFlag       = OSQCreate(&RecIcmpQ[0], Q_Max_Size);
    RecTcpQFlag        = OSQCreate(&RecTcpQ[0], Q_Max_Size);
    RecUdpQFlag        = OSQCreate(&RecUdpQ[0], Q_Max_Size);

}

/*********************************************************************************************************
    UDP^XN
*********************************************************************************************************/
void UDP_Process(void  *pdata)
{
    void *UdpTemp;
    uint8 eer;    
    
    while (1)
    {
        UdpTemp = OSQPend(RecUdpQFlag, 0, &eer);
        if (eer == OS_NO_ERR)
        {
            Udp_Process((Rec_Ptr *)UdpTemp);
            eer = eer;
    	}
    }    
}

/*********************************************************************************************************
    TCP^XN
*********************************************************************************************************/
void TCP_Process(void  *pdata) 
{
    void *TcpTemp;
    uint8 err;

    while (1)
    {
       	TcpTemp = OSQPend(RecTcpQFlag,0,&err);
        if (err == OS_NO_ERR)
        {
            Process_Tcp1((Rec_Ptr *) TcpTemp);
	    TcpTemp = TcpTemp;
        }
    }    
}

/*********************************************************************************************************
    ARP^XN
*********************************************************************************************************/
void ARP_Process(void  *pdata)
{
    OSTimeDly(OS_TICKS_PER_SEC * 5);
    Initial_arp();
    OSTaskDel(OS_PRIO_SELF);
}

/*********************************************************************************************************
    END FILE 
*********************************************************************************************************/
