#define ARP_GLOBALS

#include "..\User\includes.h"

typedef struct
{
    uint16 HardwareType;
    uint16 ProtocalType;
    uint8  HardwareLen;
    uint8  ProtocalLen;
    uint16 Operation;
    uint8  SourceMacId[6];
    uint8  SourceIp[4];
    uint8  DestMacId[6];
    uint8  DestId[4];
} arp ;

uint8 ARP_REP_MAC[6]={0XFF,0XFF,0XFF,0XFF,0XFF,0XFF};
uint8 Ping_Ip_Address[4];
uint8 Ping_IP_TTL;

uint8 Arp_Answer(uint8 *ARP_REC_PTR, uint8 num)
{
    struct _pkst TxdArp;
    uint8 SEND_ARP_MAC[6];
    uint8 i;

    if (((arp*)ARP_REC_PTR)->DestId[0]==NetPort[num].My_Ip[0])
    if (((arp*)ARP_REC_PTR)->DestId[1]==NetPort[num].My_Ip[1])
    if (((arp*)ARP_REC_PTR)->DestId[2]==NetPort[num].My_Ip[2])
    if (((arp*)ARP_REC_PTR)->DestId[3]==NetPort[num].My_Ip[3])
    {
        for(i=0;i<4;i++)
        {
            SEND_ARP_MAC[i]=((arp*)ARP_REC_PTR)->SourceIp[i];
            ((arp*)ARP_REC_PTR)->SourceIp[i]=NetPort[num].My_Ip[i];
            ((arp*)ARP_REC_PTR)->DestId[i]=SEND_ARP_MAC[i];
        }
	for(i=0;i<6;i++)
        {
            SEND_ARP_MAC[i]=((arp*)ARP_REC_PTR)->SourceMacId[i];
            ((arp*)ARP_REC_PTR)->SourceMacId[i]=NetPort[num].My_Mac[i];
            ((arp*)ARP_REC_PTR)->DestMacId[i]=SEND_ARP_MAC[i];
    	}
        #ifdef Big_End
            ((arp*)ARP_REC_PTR)->Operation=0x0002;
        #endif
        #ifdef Little_End
            ((arp*)ARP_REC_PTR)->Operation=0x0200;
        #endif
	TxdArp.STPTR=NULL;
	TxdArp.length=0x60;
	TxdArp.DAPTR=ARP_REC_PTR;
	Send_ethernet_Frame(&TxdArp,SEND_ARP_MAC,ARP_PACKED,num);
	if((((arp*)ARP_REC_PTR)->SourceIp[0]&NetPort[num].My_Ip_Mark[0])==(NetPort[num].My_Ip[0]&NetPort[num].My_Ip_Mark[0]))
	if((((arp*)ARP_REC_PTR)->SourceIp[1]&NetPort[num].My_Ip_Mark[1])==(NetPort[num].My_Ip[1]&NetPort[num].My_Ip_Mark[1]))
	if((((arp*)ARP_REC_PTR)->SourceIp[2]&NetPort[num].My_Ip_Mark[2])==(NetPort[num].My_Ip[2]&NetPort[num].My_Ip_Mark[2]))
	if((((arp*)ARP_REC_PTR)->SourceIp[3]&NetPort[num].My_Ip_Mark[3])==(NetPort[num].My_Ip[3]&NetPort[num].My_Ip_Mark[3]))
	{
	    for(i=0;i<MAX_ARP_TERM;i++)
	    {
	        if(NetPort[num].ARP_TERM[i].IP_NUM[2]==((arp*)ARP_REC_PTR)->SourceIp[2])
		if(NetPort[num].ARP_TERM[i].IP_NUM[3]==((arp*)ARP_REC_PTR)->SourceIp[3])
		if(NetPort[num].ARP_TERM[i].TTL>0)
		{
		    NetPort[num].ARP_TERM[i].TTL=100;
		    return(0);
		}
	    }
	    for(i=0;i<MAX_ARP_TERM;i++)
	    {
                if(NetPort[num].ARP_TERM[i].TTL==0)
		{
                    NetPort[num].ARP_TERM[i].IP_NUM[0]=((arp*)ARP_REC_PTR)->SourceIp[0];
		    NetPort[num].ARP_TERM[i].IP_NUM[1]=((arp*)ARP_REC_PTR)->SourceIp[1];
		    NetPort[num].ARP_TERM[i].IP_NUM[2]=((arp*)ARP_REC_PTR)->SourceIp[2];
		    NetPort[num].ARP_TERM[i].IP_NUM[3]=((arp*)ARP_REC_PTR)->SourceIp[3];
		    NetPort[num].ARP_TERM[i].MAC_NUM[0]=((arp*)ARP_REC_PTR)->SourceMacId[0];
		    NetPort[num].ARP_TERM[i].MAC_NUM[1]=((arp*)ARP_REC_PTR)->SourceMacId[1];
		    NetPort[num].ARP_TERM[i].MAC_NUM[2]=((arp*)ARP_REC_PTR)->SourceMacId[2];
		    NetPort[num].ARP_TERM[i].MAC_NUM[3]=((arp*)ARP_REC_PTR)->SourceMacId[3];
		    NetPort[num].ARP_TERM[i].MAC_NUM[4]=((arp*)ARP_REC_PTR)->SourceMacId[4];
		    NetPort[num].ARP_TERM[i].MAC_NUM[5]=((arp*)ARP_REC_PTR)->SourceMacId[5];
		    NetPort[num].ARP_TERM[i].TTL=100;
		    return(2);
		}
	    }
            return(4);
	}
	return (3);
    }
    return (1);
}

uint8 REC_ARP_REQ(uint8 *ARP_REC_REQ_PTR, uint8 num)
{
    uint8 i;

    if(((arp*)ARP_REC_REQ_PTR)->SourceIp[0]==NetPort[num].My_Gateway[0])
    if(((arp*)ARP_REC_REQ_PTR)->SourceIp[1]==NetPort[num].My_Gateway[1])
    if(((arp*)ARP_REC_REQ_PTR)->SourceIp[2]==NetPort[num].My_Gateway[2])
    if(((arp*)ARP_REC_REQ_PTR)->SourceIp[3]==NetPort[num].My_Gateway[3])
    {
        for (i=0;i<6;i++)
	{
            NetPort[num].My_Gateway_Mac[i]=((arp*)ARP_REC_REQ_PTR)->SourceMacId[i];
	}
        NetPort[num].Gateway_IP_TTL=100;
    }
    if((((arp*)ARP_REC_REQ_PTR)->SourceIp[0]&NetPort[num].My_Ip_Mark[0])==(NetPort[num].My_Ip[0]&NetPort[num].My_Ip_Mark[0]))
    if((((arp*)ARP_REC_REQ_PTR)->SourceIp[1]&NetPort[num].My_Ip_Mark[1])==(NetPort[num].My_Ip[1]&NetPort[num].My_Ip_Mark[1]))
    if((((arp*)ARP_REC_REQ_PTR)->SourceIp[2]&NetPort[num].My_Ip_Mark[2])==(NetPort[num].My_Ip[2]&NetPort[num].My_Ip_Mark[2]))
    if((((arp*)ARP_REC_REQ_PTR)->SourceIp[3]&NetPort[num].My_Ip_Mark[3])==(NetPort[num].My_Ip[3]&NetPort[num].My_Ip_Mark[3]))
    {
        for(i=0;i<MAX_ARP_TERM;i++)
	{
	    if(NetPort[num].ARP_TERM[i].IP_NUM[2]==((arp*)ARP_REC_REQ_PTR)->SourceIp[2])
	    if(NetPort[num].ARP_TERM[i].IP_NUM[3]==((arp*)ARP_REC_REQ_PTR)->SourceIp[3])
	    if(NetPort[num].ARP_TERM[i].TTL>0)
	    {
	        NetPort[num].ARP_TERM[i].TTL=100;
                return(0);
	    }
	}
	for(i=0;i<MAX_ARP_TERM;i++)
	{
	    if(NetPort[num].ARP_TERM[i].TTL==0)
	    {
                NetPort[num].ARP_TERM[i].IP_NUM[0]=((arp*)ARP_REC_REQ_PTR)->SourceIp[0];
		NetPort[num].ARP_TERM[i].IP_NUM[1]=((arp*)ARP_REC_REQ_PTR)->SourceIp[1];
		NetPort[num].ARP_TERM[i].IP_NUM[2]=((arp*)ARP_REC_REQ_PTR)->SourceIp[2];
		NetPort[num].ARP_TERM[i].IP_NUM[3]=((arp*)ARP_REC_REQ_PTR)->SourceIp[3];
		NetPort[num].ARP_TERM[i].MAC_NUM[0]=((arp*)ARP_REC_REQ_PTR)->SourceMacId[0];
		NetPort[num].ARP_TERM[i].MAC_NUM[1]=((arp*)ARP_REC_REQ_PTR)->SourceMacId[1];
		NetPort[num].ARP_TERM[i].MAC_NUM[2]=((arp*)ARP_REC_REQ_PTR)->SourceMacId[2];
		NetPort[num].ARP_TERM[i].MAC_NUM[3]=((arp*)ARP_REC_REQ_PTR)->SourceMacId[3];
		NetPort[num].ARP_TERM[i].MAC_NUM[4]=((arp*)ARP_REC_REQ_PTR)->SourceMacId[4];
		NetPort[num].ARP_TERM[i].MAC_NUM[5]=((arp*)ARP_REC_REQ_PTR)->SourceMacId[5];
		NetPort[num].ARP_TERM[i].TTL=100;
		return(2);
            }
	}
	return(4);
    }
    return(1);
}

void PROCESS_ARP_REC(uint8 *ARP_PTR, uint8 num)  
{
    #ifdef Big_End
        if(((arp*)ARP_PTR)->Operation==0X0001)
    #endif
    #ifdef Little_End
        if(((arp*)ARP_PTR)->Operation==0X0100)
    #endif
    {
        Arp_Answer(ARP_PTR,num);
    }
    #ifdef Big_End
        else if(((arp*)ARP_PTR)->Operation==0X0002)
    #endif
    #ifdef Little_End
        else if(((arp*)ARP_PTR)->Operation==0X0200)
    #endif
    {
        REC_ARP_REQ(ARP_PTR, num);
    }
}

void Arp_Request(uint8 *ip_address, uint8 num)
{
    struct _pkst TxdArpReq;
    uint8 ARPREQ[46];
    uint8 i;
    for(i=0;i<6;i++)
    {
        ((arp*)ARPREQ)->SourceMacId[i]=NetPort[num].My_Mac[i];
	((arp*)ARPREQ)->DestMacId[i]=0x00;
    }
    for(i=0;i<4;i++)								
    {
        ((arp*)ARPREQ)->SourceIp[i]=NetPort[num].My_Ip[i];
	((arp*)ARPREQ)->DestId[i]=*ip_address;
	ip_address++;
    }
    #ifdef Big_End	
        ((arp*)ARPREQ)->HardwareType=0x0001;
        ((arp*)ARPREQ)->ProtocalType=0x0800;
        ((arp*)ARPREQ)->Operation=0x0001;
    #endif
    #ifdef Little_End
        ((arp*)ARPREQ)->HardwareType=0x0100;
        ((arp*)ARPREQ)->ProtocalType=0x0008;
        ((arp*)ARPREQ)->Operation=0x0100;
    #endif
    ((arp*)ARPREQ)->HardwareLen=0x06;
    ((arp*)ARPREQ)->ProtocalLen=0x04;

    ARPREQ[28]=0x00;
    TxdArpReq.STPTR=NULL;
    TxdArpReq.length=46;
    TxdArpReq.DAPTR=ARPREQ;
    Send_ethernet_Frame(&TxdArpReq, ARP_REP_MAC, ARP_PACKED, num);
}

void Initial_arp()  
{
    uint8 i, num;
    Ping_IP_TTL=0;
    for(num=0;num<MAX_NET_PORT;num++)
    {
        NetPort[num].Gateway_IP_TTL=0;
        for(i=0;i<MAX_ARP_TERM;i++)
	{
            NetPort[num].ARP_TERM[i].TTL=0;
	}
        Arp_Request(NetPort[num].My_Gateway,num);
    }
}
